﻿// v. 1.0 (15.03.2023)
// https://forum.rudtp.ru/threads/pokazat-ispolzovanie-tekstovyx-peremennyx-v-tekste.80119/
//

if (app.documents.length == 0) {
    alert("Нет открытых документов");
    exit();
    }

var myDoc = app.activeDocument;
var myTextVars = myDoc.textVariables; // всегда есть 2 скрытых (служебных)

// Собираем список имен переменных
var myTextVarsList = new Array ();
for (i = 0; i < myTextVars.length; i++){
    // отсекаем служебные и неиспользуемые переменные
    if (myTextVars[i].variableType == VariableTypes.XREF_PAGE_NUMBER_TYPE || 
        myTextVars[i].variableType == VariableTypes.XREF_CHAPTER_NUMBER_TYPE ||
        myTextVars[i].associatedInstances.length == 0
        ) continue;
   myTextVarsList.push(myTextVars[i].name);
}

// Диалоговое окно
    var myDlg = new Window ("dialog", "Поиск переменной", undefined, {closeButton: false});
    // Выпадающий список с именами переменных
    var myList = myDlg.add ("group");
    myList.add ("statictext", undefined, "Выбрать переменную:");
    var choseTextVar = myList.add ("dropdownlist", undefined, myTextVarsList);
    choseTextVar.minimumSize.width = 150;
    // группа кнопок 
    var myBtn = myDlg.add ("group");
    myBtn.alignment = "right";  
    myBtn.add ("button", undefined, "OK");
    myBtn.add ("button", undefined, "Cancel");
    // проверка нажатия кнопок
    if (myDlg.show () == 1) {
        var var_name = choseTextVar.selection.text;
        } else {exit ();}
 // end Диалоговое окно

var t_var = myTextVars.itemByName(var_name);

if (t_var.isValid)
{
    for (var i = 0; i < t_var.associatedInstances.length; i++)
    { show_it (t_var.associatedInstances[i], i+1, t_var.associatedInstances.length, var_name); }     
    } // end if

function show_it ( theObj, i, n, var_name )   
{ 
    myDoc.select (theObj.storyOffset, SelectionOptions.replaceWith, var_name); 
    app.activeWindow.zoomPercentage = 600;
    
    var msg = 
    'Переменная по имени' + '\n' +
    var_name + '\n' +
    'нашлась на стр. ' + app.activeWindow.activePage.name + '\n\n' +
    '(' + theObj.resultText  + ')' + '\n\n' + 
    'Результат ' +  i + '/' + n + '\n\n' + 
    'Дальше?';

    var _choice = confirm ( msg ); 
    if (_choice == false)   
        exit ();   
    return app.selection[0];
}

// v. 1.0 (15.03.2023) *** MV, 2023